Attribute VB_Name = "aiNet"
'                                                                         '
' Last revision: October 17 1996                                          '
'                                                                         '

Option Explicit

'
' aiNet function declarations
'
Public Declare Function aiCreateModel Lib "ainet16.dll" (ByVal nModelVectors As Integer, ByVal nVariables As Integer, ByVal nInpVariables As Integer) As Long
Public Declare Function aiCreateModelFromCSVFile Lib "ainet16.dll" (ByVal fileName As String) As Long
Public Declare Function aiDeleteModel Lib "ainet16.dll" (ByVal model As Long) As Integer
Public Declare Function aiNormalize Lib "ainet16.dll" (ByVal model As Long, ByVal method As Integer) As Integer
Public Declare Function aiDenormalize Lib "ainet16.dll" (ByVal model As Long) As Integer
Public Declare Function aiRegistration Lib "ainet16.dll" (ByVal user As String, ByVal code As String) As Integer
Public Declare Function aiPrediction Lib "ainet16.dll" (ByVal model As Long, toPredict As Single, ByVal penalty As Single, ByVal method As Integer) As Integer
Public Declare Function aiGetVariableVB Lib "ainet16.dll" (ByVal model As Long, ByVal mv As Integer, ByVal v As Integer, value As Single) As Integer
Public Declare Function aiSetVariable Lib "ainet16.dll" (ByVal model As Long, ByVal mv As Integer, ByVal v As Integer, ByVal value As Single) As Integer
Public Declare Function aiGetCSVFileModelSize Lib "ainet16.dll" (ByVal fileName As String) As Integer
Public Declare Function aiGetVersion Lib "ainet16.dll" () As Integer
Public Declare Function aiGetNumberOfVariables Lib "ainet16.dll" (ByVal model As Long) As Integer
Public Declare Function aiGetNumberOfModelVectors Lib "ainet16.dll" (ByVal model As Long) As Integer
Public Declare Function aiGetNumberOfInputVariables Lib "ainet16.dll" (ByVal model As Long) As Integer
Public Declare Function aiSetDiscreteFlag Lib "ainet16.dll" (ByVal model As Long, ByVal v As Integer, ByVal f As Integer) As Integer
Public Declare Function aiGetDiscreteFlag Lib "ainet16.dll" (ByVal model As Long, ByVal i As Integer) As Integer

'
' aiNet error constants
'
Public Const AIERR_NO_ERROR = 0
Public Const AIERR_PENALTY_ZERO = -1
Public Const AIERR_NO_IO_VARIABLES = -2
Public Const AIERR_PENALTY_TOO_SMALL = -3
Public Const AIERR_EMPTY_ROW = -4
Public Const AIERR_EMPTY_COLUMN = -5
Public Const AIERR_EQUAL_COLUMN = -6
Public Const AIERR_CSV_OPEN = -7
Public Const AIERR_CSV_READ = -8
Public Const AIERR_MEMORY_ALLOCATION = -9
Public Const AIERR_INVALID_POINTER = -10
Public Const AIERR_INVALID_INDEX = -11

'
' Penalty coefficient constants
'
Public Const PENALTY_STATIC = 0
Public Const PENALTY_DYNAMIC = 1
Public Const PENALTY_NEAREST = 2

'
' Normalization constants
'
Public Const NORMALIZE_REGULAR = 0
Public Const NORMALIZE_STATISTICAL = 1

